//
//	GSSerialIOKitFramework.cpp
//	 2001 Kyle Hammond
//	kyle@codeblazer.com
//	Use at your own risk.  All rights reserved.  Do not distribute without permission.
//
#include "GSSerialIOKitFramework.h"

GSSerialIOKitFramework::GSSerialIOKitFramework( ) : GSMacOSXFramework( "IOKit" ), mIOMasterPort( nil ),
			mIOIteratorNext( nil ), mIORegistryEntryCreateCFProperty( nil ), mIOServiceMatching( nil ),
			mIOServiceGetMatchingServices( nil ), mIOObjectRelease( nil )
{	if ( mFrameworkBundle != nil ) {
		mIOMasterPort = (IOMasterPortPtr) CFBundleGetFunctionPointerForName( mFrameworkBundle, CFSTR("IOMasterPort") );

		mIOIteratorNext = (IOIteratorNextPtr) CFBundleGetFunctionPointerForName( mFrameworkBundle, CFSTR("IOIteratorNext") );

		mIORegistryEntryCreateCFProperty = (IORegistryEntryCreateCFPropertyPtr)CFBundleGetFunctionPointerForName(
					mFrameworkBundle, CFSTR("IORegistryEntryCreateCFProperty") );

		mIOServiceMatching = (IOServiceMatchingPtr) CFBundleGetFunctionPointerForName( mFrameworkBundle, CFSTR("IOServiceMatching") );

		mIOServiceGetMatchingServices = (IOServiceGetMatchingServicesPtr) CFBundleGetFunctionPointerForName( mFrameworkBundle,
					CFSTR("IOServiceGetMatchingServices") );

		mIOObjectRelease = (IOObjectReleasePtr) CFBundleGetFunctionPointerForName( mFrameworkBundle, CFSTR("IOObjectRelease") );
	}
}

kern_return_t	GSSerialIOKitFramework::IOMasterPort( mach_port_t bootstrapPort, mach_port_t *masterPort ) {
	if ( mIOMasterPort )
		return mIOMasterPort( bootstrapPort, masterPort );
	else
		return cfragNoSymbolErr;
}

io_object_t GSSerialIOKitFramework::IOIteratorNext( io_iterator_t inIterator )
{	if ( mIOIteratorNext )
		return mIOIteratorNext( inIterator );
	else
		return nil;
}

CFTypeRef GSSerialIOKitFramework::IORegistryEntryCreateCFProperty( io_registry_entry_t entry, CFStringRef key,
							CFAllocatorRef allocator, IOOptionBits options )
{	if ( mIORegistryEntryCreateCFProperty )
		return mIORegistryEntryCreateCFProperty( entry, key, allocator, options );
	else
		return nil;
}

CFMutableDictionaryRef GSSerialIOKitFramework::IOServiceMatching( const char *inName )
{	if ( mIOServiceMatching )
		return mIOServiceMatching( inName );
	else
		return nil;
}

kern_return_t GSSerialIOKitFramework::IOServiceGetMatchingServices( mach_port_t masterPort, CFDictionaryRef matching,
				io_iterator_t *existing )
{	if ( mIOServiceGetMatchingServices )
		return mIOServiceGetMatchingServices( masterPort, matching, existing );
	else
		return cfragNoSymbolErr;
}

kern_return_t GSSerialIOKitFramework::IOObjectRelease( io_object_t object )
{	if ( mIOObjectRelease )
		return mIOObjectRelease( object );
	else
		return cfragNoSymbolErr;
}
