//
//	GSSystemFramework.cpp
//	 2001 Kyle Hammond
//	kyle@codeblazer.com
//	Use at your own risk.  All rights reserved.  Do not distribute without permission.
//
#include "GSSystemFramework.h"

GSSystemFramework::GSSystemFramework( ) : GSMacOSXFramework( "System" ), mtcgetattr( nil ),
			mtcsetattr( nil ), mopen( nil ), mfcntl( nil ), mclose( nil ), mwrite( nil ), mread( nil ), merror( nil )
{	if ( mFrameworkBundle != nil ) {
		mtcgetattr = (tcgetattrPtr) CFBundleGetFunctionPointerForName( mFrameworkBundle, CFSTR("tcgetattr") );

		mtcsetattr = (tcsetattrPtr) CFBundleGetFunctionPointerForName( mFrameworkBundle, CFSTR("tcsetattr") );

		mopen = (openPtr)CFBundleGetFunctionPointerForName( mFrameworkBundle, CFSTR("open") );

		mfcntl = (fcntlPtr) CFBundleGetFunctionPointerForName( mFrameworkBundle, CFSTR("fcntl") );

		mclose = (closePtr) CFBundleGetFunctionPointerForName( mFrameworkBundle, CFSTR("close") );

		mwrite = (writePtr) CFBundleGetFunctionPointerForName( mFrameworkBundle, CFSTR("write") );

		mread = (readPtr) CFBundleGetFunctionPointerForName( mFrameworkBundle, CFSTR("read") );

		merror = (__errorPtr) CFBundleGetFunctionPointerForName( mFrameworkBundle, CFSTR("__error") );
	}
}

int	GSSystemFramework::tcgetattr ( int param1, struct termios *param2 )
{	if ( mtcgetattr )
		return mtcgetattr( param1, param2 );
	else
		return -1;
}

int	GSSystemFramework::tcsetattr ( int param1, int param2, const struct termios *param3 )
{	if ( mtcsetattr )
		return mtcsetattr( param1, param2, param3 );
	else
		return -1;
}

int	GSSystemFramework::open (const char *param1, int param2, ... )
{	if ( mopen )
		return mopen( param1, param2 );//, param3 );
	else
		return -1;
}

int	GSSystemFramework::fcntl (int param1, int param2, ... )
{	if ( mfcntl )
		return mfcntl( param1, param2 );//, param3 );
	else
		return -1;
}

int	GSSystemFramework::close ( int param1 )
{	if ( mclose )
		return mclose( param1 );
	else
		return -1;
}

int	GSSystemFramework::write ( int param1, void *param2, __std(size_t) param3 )
{	if ( mwrite )
		return mwrite( param1, param2, param3 );
	else
		return -1;
}

int	GSSystemFramework::read ( int param1, void *param2, __std(size_t) param3 )
{	if ( mread )
		return mread( param1, param2, param3 );
	else
		return -1;
}

int GSSystemFramework::errno( void ) const
{	if ( merror )
		return * merror( );
	else
		return 0;
}
